// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: Management.proto

package proto.management;

/**
 * Protobuf type {@code management.SendContactInfo}
 */
public final class SendContactInfo extends
        com.google.protobuf.GeneratedMessageV3 implements
        // @@protoc_insertion_point(message_implements:management.SendContactInfo)
        SendContactInfoOrBuilder {
    private static final long serialVersionUID = 0L;

    // Use SendContactInfo.newBuilder() to construct.
    private SendContactInfo(com.google.protobuf.GeneratedMessageV3.Builder<?> builder) {
        super(builder);
    }

    private SendContactInfo() {
        username_ = "";
        contacts_ = java.util.Collections.emptyList();
        blocked_ = com.google.protobuf.LazyStringArrayList.EMPTY;
    }

    @java.lang.Override
    @SuppressWarnings({"unused"})
    protected java.lang.Object newInstance(
            UnusedPrivateParameter unused) {
        return new SendContactInfo();
    }

    @java.lang.Override
    public final com.google.protobuf.UnknownFieldSet
    getUnknownFields() {
        return this.unknownFields;
    }

    private SendContactInfo(
            com.google.protobuf.CodedInputStream input,
            com.google.protobuf.ExtensionRegistryLite extensionRegistry)
            throws com.google.protobuf.InvalidProtocolBufferException {
        this();
        if (extensionRegistry == null) {
            throw new java.lang.NullPointerException();
        }
        int mutable_bitField0_ = 0;
        com.google.protobuf.UnknownFieldSet.Builder unknownFields =
                com.google.protobuf.UnknownFieldSet.newBuilder();
        try {
            boolean done = false;
            while (!done) {
                int tag = input.readTag();
                switch (tag) {
                    case 0:
                        done = true;
                        break;
                    case 10: {
                        com.google.protobuf.ByteString bs = input.readBytes();
                        bitField0_ |= 0x00000001;
                        username_ = bs;
                        break;
                    }
                    case 18: {
                        if (!((mutable_bitField0_ & 0x00000002) != 0)) {
                            contacts_ = new java.util.ArrayList<proto.management.SendContactInfo.Contact>();
                            mutable_bitField0_ |= 0x00000002;
                        }
                        contacts_.add(
                                input.readMessage(proto.management.SendContactInfo.Contact.PARSER, extensionRegistry));
                        break;
                    }
                    case 26: {
                        com.google.protobuf.ByteString bs = input.readBytes();
                        if (!((mutable_bitField0_ & 0x00000004) != 0)) {
                            blocked_ = new com.google.protobuf.LazyStringArrayList();
                            mutable_bitField0_ |= 0x00000004;
                        }
                        blocked_.add(bs);
                        break;
                    }
                    default: {
                        if (!parseUnknownField(
                                input, unknownFields, extensionRegistry, tag)) {
                            done = true;
                        }
                        break;
                    }
                }
            }
        } catch (com.google.protobuf.InvalidProtocolBufferException e) {
            throw e.setUnfinishedMessage(this);
        } catch (java.io.IOException e) {
            throw new com.google.protobuf.InvalidProtocolBufferException(
                    e).setUnfinishedMessage(this);
        } finally {
            if (((mutable_bitField0_ & 0x00000002) != 0)) {
                contacts_ = java.util.Collections.unmodifiableList(contacts_);
            }
            if (((mutable_bitField0_ & 0x00000004) != 0)) {
                blocked_ = blocked_.getUnmodifiableView();
            }
            this.unknownFields = unknownFields.build();
            makeExtensionsImmutable();
        }
    }

    public static final com.google.protobuf.Descriptors.Descriptor
    getDescriptor() {
        return proto.management.ManagementProtos.internal_static_management_SendContactInfo_descriptor;
    }

    @java.lang.Override
    protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
    internalGetFieldAccessorTable() {
        return proto.management.ManagementProtos.internal_static_management_SendContactInfo_fieldAccessorTable
                .ensureFieldAccessorsInitialized(
                        proto.management.SendContactInfo.class, proto.management.SendContactInfo.Builder.class);
    }

    public interface ContactOrBuilder extends
            // @@protoc_insertion_point(interface_extends:management.SendContactInfo.Contact)
            com.google.protobuf.MessageOrBuilder {

        /**
         * <code>required string username = 1;</code>
         *
         * @return Whether the username field is set.
         */
        boolean hasUsername();

        /**
         * <code>required string username = 1;</code>
         *
         * @return The username.
         */
        java.lang.String getUsername();

        /**
         * <code>required string username = 1;</code>
         *
         * @return The bytes for username.
         */
        com.google.protobuf.ByteString
        getUsernameBytes();

        /**
         * <code>optional int32 world = 2;</code>
         *
         * @return Whether the world field is set.
         */
        boolean hasWorld();

        /**
         * <code>optional int32 world = 2;</code>
         *
         * @return The world.
         */
        int getWorld();

        /**
         * <code>optional int32 rank = 3;</code>
         *
         * @return Whether the rank field is set.
         */
        boolean hasRank();

        /**
         * <code>optional int32 rank = 3;</code>
         *
         * @return The rank.
         */
        int getRank();
    }

    /**
     * Protobuf type {@code management.SendContactInfo.Contact}
     */
    public static final class Contact extends
            com.google.protobuf.GeneratedMessageV3 implements
            // @@protoc_insertion_point(message_implements:management.SendContactInfo.Contact)
            ContactOrBuilder {
        private static final long serialVersionUID = 0L;

        // Use Contact.newBuilder() to construct.
        private Contact(com.google.protobuf.GeneratedMessageV3.Builder<?> builder) {
            super(builder);
        }

        private Contact() {
            username_ = "";
        }

        @java.lang.Override
        @SuppressWarnings({"unused"})
        protected java.lang.Object newInstance(
                UnusedPrivateParameter unused) {
            return new Contact();
        }

        @java.lang.Override
        public final com.google.protobuf.UnknownFieldSet
        getUnknownFields() {
            return this.unknownFields;
        }

        private Contact(
                com.google.protobuf.CodedInputStream input,
                com.google.protobuf.ExtensionRegistryLite extensionRegistry)
                throws com.google.protobuf.InvalidProtocolBufferException {
            this();
            if (extensionRegistry == null) {
                throw new java.lang.NullPointerException();
            }
            int mutable_bitField0_ = 0;
            com.google.protobuf.UnknownFieldSet.Builder unknownFields =
                    com.google.protobuf.UnknownFieldSet.newBuilder();
            try {
                boolean done = false;
                while (!done) {
                    int tag = input.readTag();
                    switch (tag) {
                        case 0:
                            done = true;
                            break;
                        case 10: {
                            com.google.protobuf.ByteString bs = input.readBytes();
                            bitField0_ |= 0x00000001;
                            username_ = bs;
                            break;
                        }
                        case 16: {
                            bitField0_ |= 0x00000002;
                            world_ = input.readInt32();
                            break;
                        }
                        case 24: {
                            bitField0_ |= 0x00000004;
                            rank_ = input.readInt32();
                            break;
                        }
                        default: {
                            if (!parseUnknownField(
                                    input, unknownFields, extensionRegistry, tag)) {
                                done = true;
                            }
                            break;
                        }
                    }
                }
            } catch (com.google.protobuf.InvalidProtocolBufferException e) {
                throw e.setUnfinishedMessage(this);
            } catch (java.io.IOException e) {
                throw new com.google.protobuf.InvalidProtocolBufferException(
                        e).setUnfinishedMessage(this);
            } finally {
                this.unknownFields = unknownFields.build();
                makeExtensionsImmutable();
            }
        }

        public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
            return proto.management.ManagementProtos.internal_static_management_SendContactInfo_Contact_descriptor;
        }

        @java.lang.Override
        protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
            return proto.management.ManagementProtos.internal_static_management_SendContactInfo_Contact_fieldAccessorTable
                    .ensureFieldAccessorsInitialized(
                            proto.management.SendContactInfo.Contact.class, proto.management.SendContactInfo.Contact.Builder.class);
        }

        private int bitField0_;
        public static final int USERNAME_FIELD_NUMBER = 1;
        private volatile java.lang.Object username_;

        /**
         * <code>required string username = 1;</code>
         *
         * @return Whether the username field is set.
         */
        @java.lang.Override
        public boolean hasUsername() {
            return ((bitField0_ & 0x00000001) != 0);
        }

        /**
         * <code>required string username = 1;</code>
         *
         * @return The username.
         */
        @java.lang.Override
        public java.lang.String getUsername() {
            java.lang.Object ref = username_;
            if (ref instanceof java.lang.String) {
                return (java.lang.String) ref;
            } else {
                com.google.protobuf.ByteString bs =
                        (com.google.protobuf.ByteString) ref;
                java.lang.String s = bs.toStringUtf8();
                if (bs.isValidUtf8()) {
                    username_ = s;
                }
                return s;
            }
        }

        /**
         * <code>required string username = 1;</code>
         *
         * @return The bytes for username.
         */
        @java.lang.Override
        public com.google.protobuf.ByteString
        getUsernameBytes() {
            java.lang.Object ref = username_;
            if (ref instanceof java.lang.String) {
                com.google.protobuf.ByteString b =
                        com.google.protobuf.ByteString.copyFromUtf8(
                                (java.lang.String) ref);
                username_ = b;
                return b;
            } else {
                return (com.google.protobuf.ByteString) ref;
            }
        }

        public static final int WORLD_FIELD_NUMBER = 2;
        private int world_;

        /**
         * <code>optional int32 world = 2;</code>
         *
         * @return Whether the world field is set.
         */
        @java.lang.Override
        public boolean hasWorld() {
            return ((bitField0_ & 0x00000002) != 0);
        }

        /**
         * <code>optional int32 world = 2;</code>
         *
         * @return The world.
         */
        @java.lang.Override
        public int getWorld() {
            return world_;
        }

        public static final int RANK_FIELD_NUMBER = 3;
        private int rank_;

        /**
         * <code>optional int32 rank = 3;</code>
         *
         * @return Whether the rank field is set.
         */
        @java.lang.Override
        public boolean hasRank() {
            return ((bitField0_ & 0x00000004) != 0);
        }

        /**
         * <code>optional int32 rank = 3;</code>
         *
         * @return The rank.
         */
        @java.lang.Override
        public int getRank() {
            return rank_;
        }

        private byte memoizedIsInitialized = -1;

        @java.lang.Override
        public final boolean isInitialized() {
            byte isInitialized = memoizedIsInitialized;
            if (isInitialized == 1) return true;
            if (isInitialized == 0) return false;

            if (!hasUsername()) {
                memoizedIsInitialized = 0;
                return false;
            }
            memoizedIsInitialized = 1;
            return true;
        }

        @java.lang.Override
        public void writeTo(com.google.protobuf.CodedOutputStream output)
                throws java.io.IOException {
            if (((bitField0_ & 0x00000001) != 0)) {
                com.google.protobuf.GeneratedMessageV3.writeString(output, 1, username_);
            }
            if (((bitField0_ & 0x00000002) != 0)) {
                output.writeInt32(2, world_);
            }
            if (((bitField0_ & 0x00000004) != 0)) {
                output.writeInt32(3, rank_);
            }
            unknownFields.writeTo(output);
        }

        @java.lang.Override
        public int getSerializedSize() {
            int size = memoizedSize;
            if (size != -1) return size;

            size = 0;
            if (((bitField0_ & 0x00000001) != 0)) {
                size += com.google.protobuf.GeneratedMessageV3.computeStringSize(1, username_);
            }
            if (((bitField0_ & 0x00000002) != 0)) {
                size += com.google.protobuf.CodedOutputStream
                        .computeInt32Size(2, world_);
            }
            if (((bitField0_ & 0x00000004) != 0)) {
                size += com.google.protobuf.CodedOutputStream
                        .computeInt32Size(3, rank_);
            }
            size += unknownFields.getSerializedSize();
            memoizedSize = size;
            return size;
        }

        @java.lang.Override
        public boolean equals(final java.lang.Object obj) {
            if (obj == this) {
                return true;
            }
            if (!(obj instanceof proto.management.SendContactInfo.Contact)) {
                return super.equals(obj);
            }
            proto.management.SendContactInfo.Contact other = (proto.management.SendContactInfo.Contact) obj;

            if (hasUsername() != other.hasUsername()) return false;
            if (hasUsername()) {
                if (!getUsername()
                        .equals(other.getUsername())) return false;
            }
            if (hasWorld() != other.hasWorld()) return false;
            if (hasWorld()) {
                if (getWorld()
                        != other.getWorld()) return false;
            }
            if (hasRank() != other.hasRank()) return false;
            if (hasRank()) {
                if (getRank()
                        != other.getRank()) return false;
            }
            if (!unknownFields.equals(other.unknownFields)) return false;
            return true;
        }

        @java.lang.Override
        public int hashCode() {
            if (memoizedHashCode != 0) {
                return memoizedHashCode;
            }
            int hash = 41;
            hash = (19 * hash) + getDescriptor().hashCode();
            if (hasUsername()) {
                hash = (37 * hash) + USERNAME_FIELD_NUMBER;
                hash = (53 * hash) + getUsername().hashCode();
            }
            if (hasWorld()) {
                hash = (37 * hash) + WORLD_FIELD_NUMBER;
                hash = (53 * hash) + getWorld();
            }
            if (hasRank()) {
                hash = (37 * hash) + RANK_FIELD_NUMBER;
                hash = (53 * hash) + getRank();
            }
            hash = (29 * hash) + unknownFields.hashCode();
            memoizedHashCode = hash;
            return hash;
        }

        public static proto.management.SendContactInfo.Contact parseFrom(
                java.nio.ByteBuffer data)
                throws com.google.protobuf.InvalidProtocolBufferException {
            return PARSER.parseFrom(data);
        }

        public static proto.management.SendContactInfo.Contact parseFrom(
                java.nio.ByteBuffer data,
                com.google.protobuf.ExtensionRegistryLite extensionRegistry)
                throws com.google.protobuf.InvalidProtocolBufferException {
            return PARSER.parseFrom(data, extensionRegistry);
        }

        public static proto.management.SendContactInfo.Contact parseFrom(
                com.google.protobuf.ByteString data)
                throws com.google.protobuf.InvalidProtocolBufferException {
            return PARSER.parseFrom(data);
        }

        public static proto.management.SendContactInfo.Contact parseFrom(
                com.google.protobuf.ByteString data,
                com.google.protobuf.ExtensionRegistryLite extensionRegistry)
                throws com.google.protobuf.InvalidProtocolBufferException {
            return PARSER.parseFrom(data, extensionRegistry);
        }

        public static proto.management.SendContactInfo.Contact parseFrom(byte[] data)
                throws com.google.protobuf.InvalidProtocolBufferException {
            return PARSER.parseFrom(data);
        }

        public static proto.management.SendContactInfo.Contact parseFrom(
                byte[] data,
                com.google.protobuf.ExtensionRegistryLite extensionRegistry)
                throws com.google.protobuf.InvalidProtocolBufferException {
            return PARSER.parseFrom(data, extensionRegistry);
        }

        public static proto.management.SendContactInfo.Contact parseFrom(java.io.InputStream input)
                throws java.io.IOException {
            return com.google.protobuf.GeneratedMessageV3
                    .parseWithIOException(PARSER, input);
        }

        public static proto.management.SendContactInfo.Contact parseFrom(
                java.io.InputStream input,
                com.google.protobuf.ExtensionRegistryLite extensionRegistry)
                throws java.io.IOException {
            return com.google.protobuf.GeneratedMessageV3
                    .parseWithIOException(PARSER, input, extensionRegistry);
        }

        public static proto.management.SendContactInfo.Contact parseDelimitedFrom(java.io.InputStream input)
                throws java.io.IOException {
            return com.google.protobuf.GeneratedMessageV3
                    .parseDelimitedWithIOException(PARSER, input);
        }

        public static proto.management.SendContactInfo.Contact parseDelimitedFrom(
                java.io.InputStream input,
                com.google.protobuf.ExtensionRegistryLite extensionRegistry)
                throws java.io.IOException {
            return com.google.protobuf.GeneratedMessageV3
                    .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
        }

        public static proto.management.SendContactInfo.Contact parseFrom(
                com.google.protobuf.CodedInputStream input)
                throws java.io.IOException {
            return com.google.protobuf.GeneratedMessageV3
                    .parseWithIOException(PARSER, input);
        }

        public static proto.management.SendContactInfo.Contact parseFrom(
                com.google.protobuf.CodedInputStream input,
                com.google.protobuf.ExtensionRegistryLite extensionRegistry)
                throws java.io.IOException {
            return com.google.protobuf.GeneratedMessageV3
                    .parseWithIOException(PARSER, input, extensionRegistry);
        }

        @java.lang.Override
        public Builder newBuilderForType() {
            return newBuilder();
        }

        public static Builder newBuilder() {
            return DEFAULT_INSTANCE.toBuilder();
        }

        public static Builder newBuilder(proto.management.SendContactInfo.Contact prototype) {
            return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
        }

        @java.lang.Override
        public Builder toBuilder() {
            return this == DEFAULT_INSTANCE
                    ? new Builder() : new Builder().mergeFrom(this);
        }

        @java.lang.Override
        protected Builder newBuilderForType(
                com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
            Builder builder = new Builder(parent);
            return builder;
        }

        /**
         * Protobuf type {@code management.SendContactInfo.Contact}
         */
        public static final class Builder extends
                com.google.protobuf.GeneratedMessageV3.Builder<Builder> implements
                // @@protoc_insertion_point(builder_implements:management.SendContactInfo.Contact)
                proto.management.SendContactInfo.ContactOrBuilder {
            public static final com.google.protobuf.Descriptors.Descriptor
            getDescriptor() {
                return proto.management.ManagementProtos.internal_static_management_SendContactInfo_Contact_descriptor;
            }

            @java.lang.Override
            protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
            internalGetFieldAccessorTable() {
                return proto.management.ManagementProtos.internal_static_management_SendContactInfo_Contact_fieldAccessorTable
                        .ensureFieldAccessorsInitialized(
                                proto.management.SendContactInfo.Contact.class, proto.management.SendContactInfo.Contact.Builder.class);
            }

            // Construct using proto.management.SendContactInfo.Contact.newBuilder()
            private Builder() {
                maybeForceBuilderInitialization();
            }

            private Builder(
                    com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
                super(parent);
                maybeForceBuilderInitialization();
            }

            private void maybeForceBuilderInitialization() {
                if (com.google.protobuf.GeneratedMessageV3
                        .alwaysUseFieldBuilders) {
                }
            }

            @java.lang.Override
            public Builder clear() {
                super.clear();
                username_ = "";
                bitField0_ = (bitField0_ & ~0x00000001);
                world_ = 0;
                bitField0_ = (bitField0_ & ~0x00000002);
                rank_ = 0;
                bitField0_ = (bitField0_ & ~0x00000004);
                return this;
            }

            @java.lang.Override
            public com.google.protobuf.Descriptors.Descriptor
            getDescriptorForType() {
                return proto.management.ManagementProtos.internal_static_management_SendContactInfo_Contact_descriptor;
            }

            @java.lang.Override
            public proto.management.SendContactInfo.Contact getDefaultInstanceForType() {
                return proto.management.SendContactInfo.Contact.getDefaultInstance();
            }

            @java.lang.Override
            public proto.management.SendContactInfo.Contact build() {
                proto.management.SendContactInfo.Contact result = buildPartial();
                if (!result.isInitialized()) {
                    throw newUninitializedMessageException(result);
                }
                return result;
            }

            @java.lang.Override
            public proto.management.SendContactInfo.Contact buildPartial() {
                proto.management.SendContactInfo.Contact result = new proto.management.SendContactInfo.Contact(this);
                int from_bitField0_ = bitField0_;
                int to_bitField0_ = 0;
                if (((from_bitField0_ & 0x00000001) != 0)) {
                    to_bitField0_ |= 0x00000001;
                }
                result.username_ = username_;
                if (((from_bitField0_ & 0x00000002) != 0)) {
                    result.world_ = world_;
                    to_bitField0_ |= 0x00000002;
                }
                if (((from_bitField0_ & 0x00000004) != 0)) {
                    result.rank_ = rank_;
                    to_bitField0_ |= 0x00000004;
                }
                result.bitField0_ = to_bitField0_;
                onBuilt();
                return result;
            }

            @java.lang.Override
            public Builder clone() {
                return super.clone();
            }

            @java.lang.Override
            public Builder setField(
                    com.google.protobuf.Descriptors.FieldDescriptor field,
                    java.lang.Object value) {
                return super.setField(field, value);
            }

            @java.lang.Override
            public Builder clearField(
                    com.google.protobuf.Descriptors.FieldDescriptor field) {
                return super.clearField(field);
            }

            @java.lang.Override
            public Builder clearOneof(
                    com.google.protobuf.Descriptors.OneofDescriptor oneof) {
                return super.clearOneof(oneof);
            }

            @java.lang.Override
            public Builder setRepeatedField(
                    com.google.protobuf.Descriptors.FieldDescriptor field,
                    int index, java.lang.Object value) {
                return super.setRepeatedField(field, index, value);
            }

            @java.lang.Override
            public Builder addRepeatedField(
                    com.google.protobuf.Descriptors.FieldDescriptor field,
                    java.lang.Object value) {
                return super.addRepeatedField(field, value);
            }

            @java.lang.Override
            public Builder mergeFrom(com.google.protobuf.Message other) {
                if (other instanceof proto.management.SendContactInfo.Contact) {
                    return mergeFrom((proto.management.SendContactInfo.Contact) other);
                } else {
                    super.mergeFrom(other);
                    return this;
                }
            }

            public Builder mergeFrom(proto.management.SendContactInfo.Contact other) {
                if (other == proto.management.SendContactInfo.Contact.getDefaultInstance()) return this;
                if (other.hasUsername()) {
                    bitField0_ |= 0x00000001;
                    username_ = other.username_;
                    onChanged();
                }
                if (other.hasWorld()) {
                    setWorld(other.getWorld());
                }
                if (other.hasRank()) {
                    setRank(other.getRank());
                }
                this.mergeUnknownFields(other.unknownFields);
                onChanged();
                return this;
            }

            @java.lang.Override
            public final boolean isInitialized() {
                if (!hasUsername()) {
                    return false;
                }
                return true;
            }

            @java.lang.Override
            public Builder mergeFrom(
                    com.google.protobuf.CodedInputStream input,
                    com.google.protobuf.ExtensionRegistryLite extensionRegistry)
                    throws java.io.IOException {
                proto.management.SendContactInfo.Contact parsedMessage = null;
                try {
                    parsedMessage = PARSER.parsePartialFrom(input, extensionRegistry);
                } catch (com.google.protobuf.InvalidProtocolBufferException e) {
                    parsedMessage = (proto.management.SendContactInfo.Contact) e.getUnfinishedMessage();
                    throw e.unwrapIOException();
                } finally {
                    if (parsedMessage != null) {
                        mergeFrom(parsedMessage);
                    }
                }
                return this;
            }

            private int bitField0_;

            private java.lang.Object username_ = "";

            /**
             * <code>required string username = 1;</code>
             *
             * @return Whether the username field is set.
             */
            public boolean hasUsername() {
                return ((bitField0_ & 0x00000001) != 0);
            }

            /**
             * <code>required string username = 1;</code>
             *
             * @return The username.
             */
            public java.lang.String getUsername() {
                java.lang.Object ref = username_;
                if (!(ref instanceof java.lang.String)) {
                    com.google.protobuf.ByteString bs =
                            (com.google.protobuf.ByteString) ref;
                    java.lang.String s = bs.toStringUtf8();
                    if (bs.isValidUtf8()) {
                        username_ = s;
                    }
                    return s;
                } else {
                    return (java.lang.String) ref;
                }
            }

            /**
             * <code>required string username = 1;</code>
             *
             * @return The bytes for username.
             */
            public com.google.protobuf.ByteString
            getUsernameBytes() {
                java.lang.Object ref = username_;
                if (ref instanceof String) {
                    com.google.protobuf.ByteString b =
                            com.google.protobuf.ByteString.copyFromUtf8(
                                    (java.lang.String) ref);
                    username_ = b;
                    return b;
                } else {
                    return (com.google.protobuf.ByteString) ref;
                }
            }

            /**
             * <code>required string username = 1;</code>
             *
             * @param value The username to set.
             * @return This builder for chaining.
             */
            public Builder setUsername(
                    java.lang.String value) {
                if (value == null) {
                    throw new NullPointerException();
                }
                bitField0_ |= 0x00000001;
                username_ = value;
                onChanged();
                return this;
            }

            /**
             * <code>required string username = 1;</code>
             *
             * @return This builder for chaining.
             */
            public Builder clearUsername() {
                bitField0_ = (bitField0_ & ~0x00000001);
                username_ = getDefaultInstance().getUsername();
                onChanged();
                return this;
            }

            /**
             * <code>required string username = 1;</code>
             *
             * @param value The bytes for username to set.
             * @return This builder for chaining.
             */
            public Builder setUsernameBytes(
                    com.google.protobuf.ByteString value) {
                if (value == null) {
                    throw new NullPointerException();
                }
                bitField0_ |= 0x00000001;
                username_ = value;
                onChanged();
                return this;
            }

            private int world_;

            /**
             * <code>optional int32 world = 2;</code>
             *
             * @return Whether the world field is set.
             */
            @java.lang.Override
            public boolean hasWorld() {
                return ((bitField0_ & 0x00000002) != 0);
            }

            /**
             * <code>optional int32 world = 2;</code>
             *
             * @return The world.
             */
            @java.lang.Override
            public int getWorld() {
                return world_;
            }

            /**
             * <code>optional int32 world = 2;</code>
             *
             * @param value The world to set.
             * @return This builder for chaining.
             */
            public Builder setWorld(int value) {
                bitField0_ |= 0x00000002;
                world_ = value;
                onChanged();
                return this;
            }

            /**
             * <code>optional int32 world = 2;</code>
             *
             * @return This builder for chaining.
             */
            public Builder clearWorld() {
                bitField0_ = (bitField0_ & ~0x00000002);
                world_ = 0;
                onChanged();
                return this;
            }

            private int rank_;

            /**
             * <code>optional int32 rank = 3;</code>
             *
             * @return Whether the rank field is set.
             */
            @java.lang.Override
            public boolean hasRank() {
                return ((bitField0_ & 0x00000004) != 0);
            }

            /**
             * <code>optional int32 rank = 3;</code>
             *
             * @return The rank.
             */
            @java.lang.Override
            public int getRank() {
                return rank_;
            }

            /**
             * <code>optional int32 rank = 3;</code>
             *
             * @param value The rank to set.
             * @return This builder for chaining.
             */
            public Builder setRank(int value) {
                bitField0_ |= 0x00000004;
                rank_ = value;
                onChanged();
                return this;
            }

            /**
             * <code>optional int32 rank = 3;</code>
             *
             * @return This builder for chaining.
             */
            public Builder clearRank() {
                bitField0_ = (bitField0_ & ~0x00000004);
                rank_ = 0;
                onChanged();
                return this;
            }

            @java.lang.Override
            public final Builder setUnknownFields(
                    final com.google.protobuf.UnknownFieldSet unknownFields) {
                return super.setUnknownFields(unknownFields);
            }

            @java.lang.Override
            public final Builder mergeUnknownFields(
                    final com.google.protobuf.UnknownFieldSet unknownFields) {
                return super.mergeUnknownFields(unknownFields);
            }


            // @@protoc_insertion_point(builder_scope:management.SendContactInfo.Contact)
        }

        // @@protoc_insertion_point(class_scope:management.SendContactInfo.Contact)
        private static final proto.management.SendContactInfo.Contact DEFAULT_INSTANCE;

        static {
            DEFAULT_INSTANCE = new proto.management.SendContactInfo.Contact();
        }

        public static proto.management.SendContactInfo.Contact getDefaultInstance() {
            return DEFAULT_INSTANCE;
        }

        @java.lang.Deprecated
        public static final com.google.protobuf.Parser<Contact>
                PARSER = new com.google.protobuf.AbstractParser<Contact>() {
            @java.lang.Override
            public Contact parsePartialFrom(
                    com.google.protobuf.CodedInputStream input,
                    com.google.protobuf.ExtensionRegistryLite extensionRegistry)
                    throws com.google.protobuf.InvalidProtocolBufferException {
                return new Contact(input, extensionRegistry);
            }
        };

        public static com.google.protobuf.Parser<Contact> parser() {
            return PARSER;
        }

        @java.lang.Override
        public com.google.protobuf.Parser<Contact> getParserForType() {
            return PARSER;
        }

        @java.lang.Override
        public proto.management.SendContactInfo.Contact getDefaultInstanceForType() {
            return DEFAULT_INSTANCE;
        }

    }

    private int bitField0_;
    public static final int USERNAME_FIELD_NUMBER = 1;
    private volatile java.lang.Object username_;

    /**
     * <code>required string username = 1;</code>
     *
     * @return Whether the username field is set.
     */
    @java.lang.Override
    public boolean hasUsername() {
        return ((bitField0_ & 0x00000001) != 0);
    }

    /**
     * <code>required string username = 1;</code>
     *
     * @return The username.
     */
    @java.lang.Override
    public java.lang.String getUsername() {
        java.lang.Object ref = username_;
        if (ref instanceof java.lang.String) {
            return (java.lang.String) ref;
        } else {
            com.google.protobuf.ByteString bs =
                    (com.google.protobuf.ByteString) ref;
            java.lang.String s = bs.toStringUtf8();
            if (bs.isValidUtf8()) {
                username_ = s;
            }
            return s;
        }
    }

    /**
     * <code>required string username = 1;</code>
     *
     * @return The bytes for username.
     */
    @java.lang.Override
    public com.google.protobuf.ByteString
    getUsernameBytes() {
        java.lang.Object ref = username_;
        if (ref instanceof java.lang.String) {
            com.google.protobuf.ByteString b =
                    com.google.protobuf.ByteString.copyFromUtf8(
                            (java.lang.String) ref);
            username_ = b;
            return b;
        } else {
            return (com.google.protobuf.ByteString) ref;
        }
    }

    public static final int CONTACTS_FIELD_NUMBER = 2;
    private java.util.List<proto.management.SendContactInfo.Contact> contacts_;

    /**
     * <code>repeated .management.SendContactInfo.Contact contacts = 2;</code>
     */
    @java.lang.Override
    public java.util.List<proto.management.SendContactInfo.Contact> getContactsList() {
        return contacts_;
    }

    /**
     * <code>repeated .management.SendContactInfo.Contact contacts = 2;</code>
     */
    @java.lang.Override
    public java.util.List<? extends proto.management.SendContactInfo.ContactOrBuilder>
    getContactsOrBuilderList() {
        return contacts_;
    }

    /**
     * <code>repeated .management.SendContactInfo.Contact contacts = 2;</code>
     */
    @java.lang.Override
    public int getContactsCount() {
        return contacts_.size();
    }

    /**
     * <code>repeated .management.SendContactInfo.Contact contacts = 2;</code>
     */
    @java.lang.Override
    public proto.management.SendContactInfo.Contact getContacts(int index) {
        return contacts_.get(index);
    }

    /**
     * <code>repeated .management.SendContactInfo.Contact contacts = 2;</code>
     */
    @java.lang.Override
    public proto.management.SendContactInfo.ContactOrBuilder getContactsOrBuilder(
            int index) {
        return contacts_.get(index);
    }

    public static final int BLOCKED_FIELD_NUMBER = 3;
    private com.google.protobuf.LazyStringList blocked_;

    /**
     * <code>repeated string blocked = 3;</code>
     *
     * @return A list containing the blocked.
     */
    public com.google.protobuf.ProtocolStringList
    getBlockedList() {
        return blocked_;
    }

    /**
     * <code>repeated string blocked = 3;</code>
     *
     * @return The count of blocked.
     */
    public int getBlockedCount() {
        return blocked_.size();
    }

    /**
     * <code>repeated string blocked = 3;</code>
     *
     * @param index The index of the element to return.
     * @return The blocked at the given index.
     */
    public java.lang.String getBlocked(int index) {
        return blocked_.get(index);
    }

    /**
     * <code>repeated string blocked = 3;</code>
     *
     * @param index The index of the value to return.
     * @return The bytes of the blocked at the given index.
     */
    public com.google.protobuf.ByteString
    getBlockedBytes(int index) {
        return blocked_.getByteString(index);
    }

    private byte memoizedIsInitialized = -1;

    @java.lang.Override
    public final boolean isInitialized() {
        byte isInitialized = memoizedIsInitialized;
        if (isInitialized == 1) return true;
        if (isInitialized == 0) return false;

        if (!hasUsername()) {
            memoizedIsInitialized = 0;
            return false;
        }
        for (int i = 0; i < getContactsCount(); i++) {
            if (!getContacts(i).isInitialized()) {
                memoizedIsInitialized = 0;
                return false;
            }
        }
        memoizedIsInitialized = 1;
        return true;
    }

    @java.lang.Override
    public void writeTo(com.google.protobuf.CodedOutputStream output)
            throws java.io.IOException {
        if (((bitField0_ & 0x00000001) != 0)) {
            com.google.protobuf.GeneratedMessageV3.writeString(output, 1, username_);
        }
        for (int i = 0; i < contacts_.size(); i++) {
            output.writeMessage(2, contacts_.get(i));
        }
        for (int i = 0; i < blocked_.size(); i++) {
            com.google.protobuf.GeneratedMessageV3.writeString(output, 3, blocked_.getRaw(i));
        }
        unknownFields.writeTo(output);
    }

    @java.lang.Override
    public int getSerializedSize() {
        int size = memoizedSize;
        if (size != -1) return size;

        size = 0;
        if (((bitField0_ & 0x00000001) != 0)) {
            size += com.google.protobuf.GeneratedMessageV3.computeStringSize(1, username_);
        }
        for (int i = 0; i < contacts_.size(); i++) {
            size += com.google.protobuf.CodedOutputStream
                    .computeMessageSize(2, contacts_.get(i));
        }
        {
            int dataSize = 0;
            for (int i = 0; i < blocked_.size(); i++) {
                dataSize += computeStringSizeNoTag(blocked_.getRaw(i));
            }
            size += dataSize;
            size += 1 * getBlockedList().size();
        }
        size += unknownFields.getSerializedSize();
        memoizedSize = size;
        return size;
    }

    @java.lang.Override
    public boolean equals(final java.lang.Object obj) {
        if (obj == this) {
            return true;
        }
        if (!(obj instanceof proto.management.SendContactInfo)) {
            return super.equals(obj);
        }
        proto.management.SendContactInfo other = (proto.management.SendContactInfo) obj;

        if (hasUsername() != other.hasUsername()) return false;
        if (hasUsername()) {
            if (!getUsername()
                    .equals(other.getUsername())) return false;
        }
        if (!getContactsList()
                .equals(other.getContactsList())) return false;
        if (!getBlockedList()
                .equals(other.getBlockedList())) return false;
        if (!unknownFields.equals(other.unknownFields)) return false;
        return true;
    }

    @java.lang.Override
    public int hashCode() {
        if (memoizedHashCode != 0) {
            return memoizedHashCode;
        }
        int hash = 41;
        hash = (19 * hash) + getDescriptor().hashCode();
        if (hasUsername()) {
            hash = (37 * hash) + USERNAME_FIELD_NUMBER;
            hash = (53 * hash) + getUsername().hashCode();
        }
        if (getContactsCount() > 0) {
            hash = (37 * hash) + CONTACTS_FIELD_NUMBER;
            hash = (53 * hash) + getContactsList().hashCode();
        }
        if (getBlockedCount() > 0) {
            hash = (37 * hash) + BLOCKED_FIELD_NUMBER;
            hash = (53 * hash) + getBlockedList().hashCode();
        }
        hash = (29 * hash) + unknownFields.hashCode();
        memoizedHashCode = hash;
        return hash;
    }

    public static proto.management.SendContactInfo parseFrom(
            java.nio.ByteBuffer data)
            throws com.google.protobuf.InvalidProtocolBufferException {
        return PARSER.parseFrom(data);
    }

    public static proto.management.SendContactInfo parseFrom(
            java.nio.ByteBuffer data,
            com.google.protobuf.ExtensionRegistryLite extensionRegistry)
            throws com.google.protobuf.InvalidProtocolBufferException {
        return PARSER.parseFrom(data, extensionRegistry);
    }

    public static proto.management.SendContactInfo parseFrom(
            com.google.protobuf.ByteString data)
            throws com.google.protobuf.InvalidProtocolBufferException {
        return PARSER.parseFrom(data);
    }

    public static proto.management.SendContactInfo parseFrom(
            com.google.protobuf.ByteString data,
            com.google.protobuf.ExtensionRegistryLite extensionRegistry)
            throws com.google.protobuf.InvalidProtocolBufferException {
        return PARSER.parseFrom(data, extensionRegistry);
    }

    public static proto.management.SendContactInfo parseFrom(byte[] data)
            throws com.google.protobuf.InvalidProtocolBufferException {
        return PARSER.parseFrom(data);
    }

    public static proto.management.SendContactInfo parseFrom(
            byte[] data,
            com.google.protobuf.ExtensionRegistryLite extensionRegistry)
            throws com.google.protobuf.InvalidProtocolBufferException {
        return PARSER.parseFrom(data, extensionRegistry);
    }

    public static proto.management.SendContactInfo parseFrom(java.io.InputStream input)
            throws java.io.IOException {
        return com.google.protobuf.GeneratedMessageV3
                .parseWithIOException(PARSER, input);
    }

    public static proto.management.SendContactInfo parseFrom(
            java.io.InputStream input,
            com.google.protobuf.ExtensionRegistryLite extensionRegistry)
            throws java.io.IOException {
        return com.google.protobuf.GeneratedMessageV3
                .parseWithIOException(PARSER, input, extensionRegistry);
    }

    public static proto.management.SendContactInfo parseDelimitedFrom(java.io.InputStream input)
            throws java.io.IOException {
        return com.google.protobuf.GeneratedMessageV3
                .parseDelimitedWithIOException(PARSER, input);
    }

    public static proto.management.SendContactInfo parseDelimitedFrom(
            java.io.InputStream input,
            com.google.protobuf.ExtensionRegistryLite extensionRegistry)
            throws java.io.IOException {
        return com.google.protobuf.GeneratedMessageV3
                .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
    }

    public static proto.management.SendContactInfo parseFrom(
            com.google.protobuf.CodedInputStream input)
            throws java.io.IOException {
        return com.google.protobuf.GeneratedMessageV3
                .parseWithIOException(PARSER, input);
    }

    public static proto.management.SendContactInfo parseFrom(
            com.google.protobuf.CodedInputStream input,
            com.google.protobuf.ExtensionRegistryLite extensionRegistry)
            throws java.io.IOException {
        return com.google.protobuf.GeneratedMessageV3
                .parseWithIOException(PARSER, input, extensionRegistry);
    }

    @java.lang.Override
    public Builder newBuilderForType() {
        return newBuilder();
    }

    public static Builder newBuilder() {
        return DEFAULT_INSTANCE.toBuilder();
    }

    public static Builder newBuilder(proto.management.SendContactInfo prototype) {
        return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
    }

    @java.lang.Override
    public Builder toBuilder() {
        return this == DEFAULT_INSTANCE
                ? new Builder() : new Builder().mergeFrom(this);
    }

    @java.lang.Override
    protected Builder newBuilderForType(
            com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
        Builder builder = new Builder(parent);
        return builder;
    }

    /**
     * Protobuf type {@code management.SendContactInfo}
     */
    public static final class Builder extends
            com.google.protobuf.GeneratedMessageV3.Builder<Builder> implements
            // @@protoc_insertion_point(builder_implements:management.SendContactInfo)
            proto.management.SendContactInfoOrBuilder {
        public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
            return proto.management.ManagementProtos.internal_static_management_SendContactInfo_descriptor;
        }

        @java.lang.Override
        protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
            return proto.management.ManagementProtos.internal_static_management_SendContactInfo_fieldAccessorTable
                    .ensureFieldAccessorsInitialized(
                            proto.management.SendContactInfo.class, proto.management.SendContactInfo.Builder.class);
        }

        // Construct using proto.management.SendContactInfo.newBuilder()
        private Builder() {
            maybeForceBuilderInitialization();
        }

        private Builder(
                com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
            super(parent);
            maybeForceBuilderInitialization();
        }

        private void maybeForceBuilderInitialization() {
            if (com.google.protobuf.GeneratedMessageV3
                    .alwaysUseFieldBuilders) {
                getContactsFieldBuilder();
            }
        }

        @java.lang.Override
        public Builder clear() {
            super.clear();
            username_ = "";
            bitField0_ = (bitField0_ & ~0x00000001);
            if (contactsBuilder_ == null) {
                contacts_ = java.util.Collections.emptyList();
                bitField0_ = (bitField0_ & ~0x00000002);
            } else {
                contactsBuilder_.clear();
            }
            blocked_ = com.google.protobuf.LazyStringArrayList.EMPTY;
            bitField0_ = (bitField0_ & ~0x00000004);
            return this;
        }

        @java.lang.Override
        public com.google.protobuf.Descriptors.Descriptor
        getDescriptorForType() {
            return proto.management.ManagementProtos.internal_static_management_SendContactInfo_descriptor;
        }

        @java.lang.Override
        public proto.management.SendContactInfo getDefaultInstanceForType() {
            return proto.management.SendContactInfo.getDefaultInstance();
        }

        @java.lang.Override
        public proto.management.SendContactInfo build() {
            proto.management.SendContactInfo result = buildPartial();
            if (!result.isInitialized()) {
                throw newUninitializedMessageException(result);
            }
            return result;
        }

        @java.lang.Override
        public proto.management.SendContactInfo buildPartial() {
            proto.management.SendContactInfo result = new proto.management.SendContactInfo(this);
            int from_bitField0_ = bitField0_;
            int to_bitField0_ = 0;
            if (((from_bitField0_ & 0x00000001) != 0)) {
                to_bitField0_ |= 0x00000001;
            }
            result.username_ = username_;
            if (contactsBuilder_ == null) {
                if (((bitField0_ & 0x00000002) != 0)) {
                    contacts_ = java.util.Collections.unmodifiableList(contacts_);
                    bitField0_ = (bitField0_ & ~0x00000002);
                }
                result.contacts_ = contacts_;
            } else {
                result.contacts_ = contactsBuilder_.build();
            }
            if (((bitField0_ & 0x00000004) != 0)) {
                blocked_ = blocked_.getUnmodifiableView();
                bitField0_ = (bitField0_ & ~0x00000004);
            }
            result.blocked_ = blocked_;
            result.bitField0_ = to_bitField0_;
            onBuilt();
            return result;
        }

        @java.lang.Override
        public Builder clone() {
            return super.clone();
        }

        @java.lang.Override
        public Builder setField(
                com.google.protobuf.Descriptors.FieldDescriptor field,
                java.lang.Object value) {
            return super.setField(field, value);
        }

        @java.lang.Override
        public Builder clearField(
                com.google.protobuf.Descriptors.FieldDescriptor field) {
            return super.clearField(field);
        }

        @java.lang.Override
        public Builder clearOneof(
                com.google.protobuf.Descriptors.OneofDescriptor oneof) {
            return super.clearOneof(oneof);
        }

        @java.lang.Override
        public Builder setRepeatedField(
                com.google.protobuf.Descriptors.FieldDescriptor field,
                int index, java.lang.Object value) {
            return super.setRepeatedField(field, index, value);
        }

        @java.lang.Override
        public Builder addRepeatedField(
                com.google.protobuf.Descriptors.FieldDescriptor field,
                java.lang.Object value) {
            return super.addRepeatedField(field, value);
        }

        @java.lang.Override
        public Builder mergeFrom(com.google.protobuf.Message other) {
            if (other instanceof proto.management.SendContactInfo) {
                return mergeFrom((proto.management.SendContactInfo) other);
            } else {
                super.mergeFrom(other);
                return this;
            }
        }

        public Builder mergeFrom(proto.management.SendContactInfo other) {
            if (other == proto.management.SendContactInfo.getDefaultInstance()) return this;
            if (other.hasUsername()) {
                bitField0_ |= 0x00000001;
                username_ = other.username_;
                onChanged();
            }
            if (contactsBuilder_ == null) {
                if (!other.contacts_.isEmpty()) {
                    if (contacts_.isEmpty()) {
                        contacts_ = other.contacts_;
                        bitField0_ = (bitField0_ & ~0x00000002);
                    } else {
                        ensureContactsIsMutable();
                        contacts_.addAll(other.contacts_);
                    }
                    onChanged();
                }
            } else {
                if (!other.contacts_.isEmpty()) {
                    if (contactsBuilder_.isEmpty()) {
                        contactsBuilder_.dispose();
                        contactsBuilder_ = null;
                        contacts_ = other.contacts_;
                        bitField0_ = (bitField0_ & ~0x00000002);
                        contactsBuilder_ =
                                com.google.protobuf.GeneratedMessageV3.alwaysUseFieldBuilders ?
                                        getContactsFieldBuilder() : null;
                    } else {
                        contactsBuilder_.addAllMessages(other.contacts_);
                    }
                }
            }
            if (!other.blocked_.isEmpty()) {
                if (blocked_.isEmpty()) {
                    blocked_ = other.blocked_;
                    bitField0_ = (bitField0_ & ~0x00000004);
                } else {
                    ensureBlockedIsMutable();
                    blocked_.addAll(other.blocked_);
                }
                onChanged();
            }
            this.mergeUnknownFields(other.unknownFields);
            onChanged();
            return this;
        }

        @java.lang.Override
        public final boolean isInitialized() {
            if (!hasUsername()) {
                return false;
            }
            for (int i = 0; i < getContactsCount(); i++) {
                if (!getContacts(i).isInitialized()) {
                    return false;
                }
            }
            return true;
        }

        @java.lang.Override
        public Builder mergeFrom(
                com.google.protobuf.CodedInputStream input,
                com.google.protobuf.ExtensionRegistryLite extensionRegistry)
                throws java.io.IOException {
            proto.management.SendContactInfo parsedMessage = null;
            try {
                parsedMessage = PARSER.parsePartialFrom(input, extensionRegistry);
            } catch (com.google.protobuf.InvalidProtocolBufferException e) {
                parsedMessage = (proto.management.SendContactInfo) e.getUnfinishedMessage();
                throw e.unwrapIOException();
            } finally {
                if (parsedMessage != null) {
                    mergeFrom(parsedMessage);
                }
            }
            return this;
        }

        private int bitField0_;

        private java.lang.Object username_ = "";

        /**
         * <code>required string username = 1;</code>
         *
         * @return Whether the username field is set.
         */
        public boolean hasUsername() {
            return ((bitField0_ & 0x00000001) != 0);
        }

        /**
         * <code>required string username = 1;</code>
         *
         * @return The username.
         */
        public java.lang.String getUsername() {
            java.lang.Object ref = username_;
            if (!(ref instanceof java.lang.String)) {
                com.google.protobuf.ByteString bs =
                        (com.google.protobuf.ByteString) ref;
                java.lang.String s = bs.toStringUtf8();
                if (bs.isValidUtf8()) {
                    username_ = s;
                }
                return s;
            } else {
                return (java.lang.String) ref;
            }
        }

        /**
         * <code>required string username = 1;</code>
         *
         * @return The bytes for username.
         */
        public com.google.protobuf.ByteString
        getUsernameBytes() {
            java.lang.Object ref = username_;
            if (ref instanceof String) {
                com.google.protobuf.ByteString b =
                        com.google.protobuf.ByteString.copyFromUtf8(
                                (java.lang.String) ref);
                username_ = b;
                return b;
            } else {
                return (com.google.protobuf.ByteString) ref;
            }
        }

        /**
         * <code>required string username = 1;</code>
         *
         * @param value The username to set.
         * @return This builder for chaining.
         */
        public Builder setUsername(
                java.lang.String value) {
            if (value == null) {
                throw new NullPointerException();
            }
            bitField0_ |= 0x00000001;
            username_ = value;
            onChanged();
            return this;
        }

        /**
         * <code>required string username = 1;</code>
         *
         * @return This builder for chaining.
         */
        public Builder clearUsername() {
            bitField0_ = (bitField0_ & ~0x00000001);
            username_ = getDefaultInstance().getUsername();
            onChanged();
            return this;
        }

        /**
         * <code>required string username = 1;</code>
         *
         * @param value The bytes for username to set.
         * @return This builder for chaining.
         */
        public Builder setUsernameBytes(
                com.google.protobuf.ByteString value) {
            if (value == null) {
                throw new NullPointerException();
            }
            bitField0_ |= 0x00000001;
            username_ = value;
            onChanged();
            return this;
        }

        private java.util.List<proto.management.SendContactInfo.Contact> contacts_ =
                java.util.Collections.emptyList();

        private void ensureContactsIsMutable() {
            if (!((bitField0_ & 0x00000002) != 0)) {
                contacts_ = new java.util.ArrayList<proto.management.SendContactInfo.Contact>(contacts_);
                bitField0_ |= 0x00000002;
            }
        }

        private com.google.protobuf.RepeatedFieldBuilderV3<
                proto.management.SendContactInfo.Contact, proto.management.SendContactInfo.Contact.Builder, proto.management.SendContactInfo.ContactOrBuilder> contactsBuilder_;

        /**
         * <code>repeated .management.SendContactInfo.Contact contacts = 2;</code>
         */
        public java.util.List<proto.management.SendContactInfo.Contact> getContactsList() {
            if (contactsBuilder_ == null) {
                return java.util.Collections.unmodifiableList(contacts_);
            } else {
                return contactsBuilder_.getMessageList();
            }
        }

        /**
         * <code>repeated .management.SendContactInfo.Contact contacts = 2;</code>
         */
        public int getContactsCount() {
            if (contactsBuilder_ == null) {
                return contacts_.size();
            } else {
                return contactsBuilder_.getCount();
            }
        }

        /**
         * <code>repeated .management.SendContactInfo.Contact contacts = 2;</code>
         */
        public proto.management.SendContactInfo.Contact getContacts(int index) {
            if (contactsBuilder_ == null) {
                return contacts_.get(index);
            } else {
                return contactsBuilder_.getMessage(index);
            }
        }

        /**
         * <code>repeated .management.SendContactInfo.Contact contacts = 2;</code>
         */
        public Builder setContacts(
                int index, proto.management.SendContactInfo.Contact value) {
            if (contactsBuilder_ == null) {
                if (value == null) {
                    throw new NullPointerException();
                }
                ensureContactsIsMutable();
                contacts_.set(index, value);
                onChanged();
            } else {
                contactsBuilder_.setMessage(index, value);
            }
            return this;
        }

        /**
         * <code>repeated .management.SendContactInfo.Contact contacts = 2;</code>
         */
        public Builder setContacts(
                int index, proto.management.SendContactInfo.Contact.Builder builderForValue) {
            if (contactsBuilder_ == null) {
                ensureContactsIsMutable();
                contacts_.set(index, builderForValue.build());
                onChanged();
            } else {
                contactsBuilder_.setMessage(index, builderForValue.build());
            }
            return this;
        }

        /**
         * <code>repeated .management.SendContactInfo.Contact contacts = 2;</code>
         */
        public Builder addContacts(proto.management.SendContactInfo.Contact value) {
            if (contactsBuilder_ == null) {
                if (value == null) {
                    throw new NullPointerException();
                }
                ensureContactsIsMutable();
                contacts_.add(value);
                onChanged();
            } else {
                contactsBuilder_.addMessage(value);
            }
            return this;
        }

        /**
         * <code>repeated .management.SendContactInfo.Contact contacts = 2;</code>
         */
        public Builder addContacts(
                int index, proto.management.SendContactInfo.Contact value) {
            if (contactsBuilder_ == null) {
                if (value == null) {
                    throw new NullPointerException();
                }
                ensureContactsIsMutable();
                contacts_.add(index, value);
                onChanged();
            } else {
                contactsBuilder_.addMessage(index, value);
            }
            return this;
        }

        /**
         * <code>repeated .management.SendContactInfo.Contact contacts = 2;</code>
         */
        public Builder addContacts(
                proto.management.SendContactInfo.Contact.Builder builderForValue) {
            if (contactsBuilder_ == null) {
                ensureContactsIsMutable();
                contacts_.add(builderForValue.build());
                onChanged();
            } else {
                contactsBuilder_.addMessage(builderForValue.build());
            }
            return this;
        }

        /**
         * <code>repeated .management.SendContactInfo.Contact contacts = 2;</code>
         */
        public Builder addContacts(
                int index, proto.management.SendContactInfo.Contact.Builder builderForValue) {
            if (contactsBuilder_ == null) {
                ensureContactsIsMutable();
                contacts_.add(index, builderForValue.build());
                onChanged();
            } else {
                contactsBuilder_.addMessage(index, builderForValue.build());
            }
            return this;
        }

        /**
         * <code>repeated .management.SendContactInfo.Contact contacts = 2;</code>
         */
        public Builder addAllContacts(
                java.lang.Iterable<? extends proto.management.SendContactInfo.Contact> values) {
            if (contactsBuilder_ == null) {
                ensureContactsIsMutable();
                com.google.protobuf.AbstractMessageLite.Builder.addAll(
                        values, contacts_);
                onChanged();
            } else {
                contactsBuilder_.addAllMessages(values);
            }
            return this;
        }

        /**
         * <code>repeated .management.SendContactInfo.Contact contacts = 2;</code>
         */
        public Builder clearContacts() {
            if (contactsBuilder_ == null) {
                contacts_ = java.util.Collections.emptyList();
                bitField0_ = (bitField0_ & ~0x00000002);
                onChanged();
            } else {
                contactsBuilder_.clear();
            }
            return this;
        }

        /**
         * <code>repeated .management.SendContactInfo.Contact contacts = 2;</code>
         */
        public Builder removeContacts(int index) {
            if (contactsBuilder_ == null) {
                ensureContactsIsMutable();
                contacts_.remove(index);
                onChanged();
            } else {
                contactsBuilder_.remove(index);
            }
            return this;
        }

        /**
         * <code>repeated .management.SendContactInfo.Contact contacts = 2;</code>
         */
        public proto.management.SendContactInfo.Contact.Builder getContactsBuilder(
                int index) {
            return getContactsFieldBuilder().getBuilder(index);
        }

        /**
         * <code>repeated .management.SendContactInfo.Contact contacts = 2;</code>
         */
        public proto.management.SendContactInfo.ContactOrBuilder getContactsOrBuilder(
                int index) {
            if (contactsBuilder_ == null) {
                return contacts_.get(index);
            } else {
                return contactsBuilder_.getMessageOrBuilder(index);
            }
        }

        /**
         * <code>repeated .management.SendContactInfo.Contact contacts = 2;</code>
         */
        public java.util.List<? extends proto.management.SendContactInfo.ContactOrBuilder>
        getContactsOrBuilderList() {
            if (contactsBuilder_ != null) {
                return contactsBuilder_.getMessageOrBuilderList();
            } else {
                return java.util.Collections.unmodifiableList(contacts_);
            }
        }

        /**
         * <code>repeated .management.SendContactInfo.Contact contacts = 2;</code>
         */
        public proto.management.SendContactInfo.Contact.Builder addContactsBuilder() {
            return getContactsFieldBuilder().addBuilder(
                    proto.management.SendContactInfo.Contact.getDefaultInstance());
        }

        /**
         * <code>repeated .management.SendContactInfo.Contact contacts = 2;</code>
         */
        public proto.management.SendContactInfo.Contact.Builder addContactsBuilder(
                int index) {
            return getContactsFieldBuilder().addBuilder(
                    index, proto.management.SendContactInfo.Contact.getDefaultInstance());
        }

        /**
         * <code>repeated .management.SendContactInfo.Contact contacts = 2;</code>
         */
        public java.util.List<proto.management.SendContactInfo.Contact.Builder>
        getContactsBuilderList() {
            return getContactsFieldBuilder().getBuilderList();
        }

        private com.google.protobuf.RepeatedFieldBuilderV3<
                proto.management.SendContactInfo.Contact, proto.management.SendContactInfo.Contact.Builder, proto.management.SendContactInfo.ContactOrBuilder>
        getContactsFieldBuilder() {
            if (contactsBuilder_ == null) {
                contactsBuilder_ = new com.google.protobuf.RepeatedFieldBuilderV3<
                        proto.management.SendContactInfo.Contact, proto.management.SendContactInfo.Contact.Builder, proto.management.SendContactInfo.ContactOrBuilder>(
                        contacts_,
                        ((bitField0_ & 0x00000002) != 0),
                        getParentForChildren(),
                        isClean());
                contacts_ = null;
            }
            return contactsBuilder_;
        }

        private com.google.protobuf.LazyStringList blocked_ = com.google.protobuf.LazyStringArrayList.EMPTY;

        private void ensureBlockedIsMutable() {
            if (!((bitField0_ & 0x00000004) != 0)) {
                blocked_ = new com.google.protobuf.LazyStringArrayList(blocked_);
                bitField0_ |= 0x00000004;
            }
        }

        /**
         * <code>repeated string blocked = 3;</code>
         *
         * @return A list containing the blocked.
         */
        public com.google.protobuf.ProtocolStringList
        getBlockedList() {
            return blocked_.getUnmodifiableView();
        }

        /**
         * <code>repeated string blocked = 3;</code>
         *
         * @return The count of blocked.
         */
        public int getBlockedCount() {
            return blocked_.size();
        }

        /**
         * <code>repeated string blocked = 3;</code>
         *
         * @param index The index of the element to return.
         * @return The blocked at the given index.
         */
        public java.lang.String getBlocked(int index) {
            return blocked_.get(index);
        }

        /**
         * <code>repeated string blocked = 3;</code>
         *
         * @param index The index of the value to return.
         * @return The bytes of the blocked at the given index.
         */
        public com.google.protobuf.ByteString
        getBlockedBytes(int index) {
            return blocked_.getByteString(index);
        }

        /**
         * <code>repeated string blocked = 3;</code>
         *
         * @param index The index to set the value at.
         * @param value The blocked to set.
         * @return This builder for chaining.
         */
        public Builder setBlocked(
                int index, java.lang.String value) {
            if (value == null) {
                throw new NullPointerException();
            }
            ensureBlockedIsMutable();
            blocked_.set(index, value);
            onChanged();
            return this;
        }

        /**
         * <code>repeated string blocked = 3;</code>
         *
         * @param value The blocked to add.
         * @return This builder for chaining.
         */
        public Builder addBlocked(
                java.lang.String value) {
            if (value == null) {
                throw new NullPointerException();
            }
            ensureBlockedIsMutable();
            blocked_.add(value);
            onChanged();
            return this;
        }

        /**
         * <code>repeated string blocked = 3;</code>
         *
         * @param values The blocked to add.
         * @return This builder for chaining.
         */
        public Builder addAllBlocked(
                java.lang.Iterable<java.lang.String> values) {
            ensureBlockedIsMutable();
            com.google.protobuf.AbstractMessageLite.Builder.addAll(
                    values, blocked_);
            onChanged();
            return this;
        }

        /**
         * <code>repeated string blocked = 3;</code>
         *
         * @return This builder for chaining.
         */
        public Builder clearBlocked() {
            blocked_ = com.google.protobuf.LazyStringArrayList.EMPTY;
            bitField0_ = (bitField0_ & ~0x00000004);
            onChanged();
            return this;
        }

        /**
         * <code>repeated string blocked = 3;</code>
         *
         * @param value The bytes of the blocked to add.
         * @return This builder for chaining.
         */
        public Builder addBlockedBytes(
                com.google.protobuf.ByteString value) {
            if (value == null) {
                throw new NullPointerException();
            }
            ensureBlockedIsMutable();
            blocked_.add(value);
            onChanged();
            return this;
        }

        @java.lang.Override
        public final Builder setUnknownFields(
                final com.google.protobuf.UnknownFieldSet unknownFields) {
            return super.setUnknownFields(unknownFields);
        }

        @java.lang.Override
        public final Builder mergeUnknownFields(
                final com.google.protobuf.UnknownFieldSet unknownFields) {
            return super.mergeUnknownFields(unknownFields);
        }


        // @@protoc_insertion_point(builder_scope:management.SendContactInfo)
    }

    // @@protoc_insertion_point(class_scope:management.SendContactInfo)
    private static final proto.management.SendContactInfo DEFAULT_INSTANCE;

    static {
        DEFAULT_INSTANCE = new proto.management.SendContactInfo();
    }

    public static proto.management.SendContactInfo getDefaultInstance() {
        return DEFAULT_INSTANCE;
    }

    @java.lang.Deprecated
    public static final com.google.protobuf.Parser<SendContactInfo>
            PARSER = new com.google.protobuf.AbstractParser<SendContactInfo>() {
        @java.lang.Override
        public SendContactInfo parsePartialFrom(
                com.google.protobuf.CodedInputStream input,
                com.google.protobuf.ExtensionRegistryLite extensionRegistry)
                throws com.google.protobuf.InvalidProtocolBufferException {
            return new SendContactInfo(input, extensionRegistry);
        }
    };

    public static com.google.protobuf.Parser<SendContactInfo> parser() {
        return PARSER;
    }

    @java.lang.Override
    public com.google.protobuf.Parser<SendContactInfo> getParserForType() {
        return PARSER;
    }

    @java.lang.Override
    public proto.management.SendContactInfo getDefaultInstanceForType() {
        return DEFAULT_INSTANCE;
    }

}

